$! 'f$verify(0)'
$! BOOKSHELF.COM Version 0.8; A small script to traverse bookshelf files
$! It is intended for use with the OSU HTTP_SERVER
$! Author: Stellan Lagerstrm <stellanl@e.kth.se>
$! Copyright: None. Share and, if possible, enjoy
$! Book references from here will be URLs like
$!  /book/ABCNKVD.DECW$BOOK	! the book as a whole: output the TOC
$! not the more specific
$!  /book/ABCNKVD.DECW$BOOK/7	! a page in the book
$!============================================================================
$	say := "write net_link"
$	crlf = F$FAO("!/")
$	url=p2 !Should look like /htbindir/bookshelf/a/b/c?shelf
$	sh sym url !debugging
$	say "<DNETARG>"
$	READ net_link shelf
$	shelf=F$EDIT(shelf-"?","UPCASE")
$	IF shelf .EQS. "" THEN shelf=F$TRNLNM("DECW$BOOKSHELF")
$	IF shelf .EQS. "" THEN shelf="LIBRARY"
$! This could have been a straight F$PARSE(shelf,"DECW$BOOK:.DECW$BOOKSHELF")
$! BUT that goes down in flames if DECW$BOOK: is a search list...
$	shelfname=F$PARSE(shelf,,,"NAME","SYNTAX_ONLY")
$	shelftype=F$PARSE(shelf,,,"TYPE","SYNTAX_ONLY")
$	shelfdir=F$PARSE(shelf,"FOO:[FOO]",,"DIRECTORY","SYNTAX_ONLY")
$	shelfdev=F$PARSE(shelf,"FOO:[FOO]",,"DEVICE","SYNTAX_ONLY")
$	IF (shelfdev .EQS. "FOO:") .AND. (shelfdir .EQS. "[FOO]")
$	  THEN shelf="DECW$BOOK:"+shelf
$	  shelfdir=""
$	  shelfdev=""
$	ENDIF
$	IF shelftype .EQS. "." THEN shelf=shelf+".DECW$BOOKSHELF"
$!
$	say "<DNETRECMODE>"
$	say "<DNETCGI>"
$	say "Content-Type: text/html",crlf
$	here=F$ELEMENT(1,"/",url)
$	self=F$ELEMENT(2,"/",url)
$!	IF F$EDIT(self,"UPCASE") .NES. "BOOKSHELF" THEN GOTO nofile !sanity
$	say "<!-- shelf ",shelf," ",shelfdev," ",shelfdir," -->" !debug
$	i=1
$uloop: u'i'=F$ELEMENT(i+2,"/",url)
$	IF u'i' .EQS. "/" THEN GOTO uend
$	i=i+1
$	GOTO uloop
$uend:	i=i-1 ! number of arguments
$	IF i .EQ. 0 ! No title
$	  THEN tit=shelfname
$	       hdr="<H2> "+shelfname+"</H2>
$	       url=url+"/"+shelfname
$	  ELSE
$	  j=1
$	  tit=""
$	  hdr=""
$tloop:   if j .GT. i THEN GOTO tend 	! for each title
$	  tit=tit+":"+u'j'
$	  hdr=hdr+"<H"+F$STRING(j+1)+"> "+F$EXTRACT(0,2*j,"        ")+u'j'+"</H"+F$STRING(j+1)+">"
$	  j=j+1
$	  goto tloop
$tend:	  tit=tit-":"
$	ENDIF
$	i=0
$	OPEN/READ/ERROR=nofile f 'shelf'
$	say "<HTML><HEAD><TITLE>''tit'</TITLE></HEAD><BODY><H1>Bookshelf</H1>",hdr,"<HR>"
$!
$floop:	READ/END=fend/error=nofile f s !loop over each shelf record
$	kind=F$EDIT(F$ELEMENT(0,"\",s),"UPCASE") !BOOK or SHELF
$	file=shelfdev+shelfdir+F$EDIT(F$ELEMENT(1,"\",s),"UPCASE")
$	name=F$ELEMENT(2,"\",s)
$!	say "<!-- ",kind," - ", file," - ", name, " -->"
$	IF kind .EQS. "SHELF"
$	THEN !escapify spaces in the name
$	  uname=url+"/"+name
$	  ename=""
$	  i=0
$nloop:	  a=F$ELEMENT(i," ",uname)
$	  if a .EQS. " " THEN GOTO n_ok
$	  i=i+1
$	  ename=ename+"%20"+a
$	  GOTO nloop
$n_ok:	  ename=ename-"%20"
$	  say "<BR><IMG SRC=""/book_figures/shelf.gif""ALT=""SHELF"">"
$	  say " <A HREF=""''ename'?''file'"">" !this gets LONG...
$	  say "''name'</A>"
$	ENDIF
$	IF kind .EQS. "BOOK" 
$	THEN 
$	 file2=file
$	 IF F$LOCATE(".",file2).EQ.F$LENGTH(file2) THEN file2=file2+".DECW$BOOK"
$	 say "<BR><IMG SRC=""/book_figures/book.gif"" ALT=""BOOK""> <A HREF=""/book/''file2'"">''name' [''file']</A>"
$	ENDIF
$	goto floop
$!
$fend:	CLOSE f
$done:	SAY "</BODY></HTML>"
$!
$       say "</DNETCGI>"
$	exit
$!
$nofile:say "%HTBOOK-E-NOSHELF Could not open file ''shelf' "+crlf+F$MESSAGE($STATUS)
$	goto done
